/* Sistemas Integrados TECNISA
   Compras e Suprimentos

Nome: 8962_SUPFUNO_CALC_DTEMBARQUECLI_OL.SQL

Descrio:
clculo da data de embarque do OL para o pedido do cliente.

Criao:
Criada para a verso 5.80 no dia 11/11/2014
*/

CREATE OR REPLACE FUNCTION CALC_DTEMBARQUECLI_OL(
   P_CDFILIOPELOG IN FILIAL.CDFILIAL%TYPE,
   P_CDCLIENTE    IN CLIENTE.CDCLIENTE%TYPE,
   P_CDARVPROD    IN PRODUTO.CDARVPROD%TYPE,
   P_DTENTREGA    IN DATE) RETURN DATE IS

   V_NRLIMISEGU        NUMBER(5);
   V_NRCONTA           NUMBER(5);

   V_DTENTREGA         DATE;
   V_ENTREGA_MENOS_ANO DATE;
   V_ENTREGA_MENOS_DIA DATE;

   V_CONTAUXI          INT;

   V_IDDNULIMSEG       CHAR(1);
   W_N                 CHAR(1):= 'N';
   W_S                 CHAR(1):= 'S';

   /* Cursor com dias teis no intervalo de um ano a partir da data de entrega */
   CURSOR C_MAIORDATA IS
      SELECT DTDATA
        FROM DATA
       WHERE (DTDATA BETWEEN V_ENTREGA_MENOS_ANO AND V_ENTREGA_MENOS_DIA)
         AND ((V_IDDNULIMSEG = W_N) OR ((V_IDDNULIMSEG = W_S)
         AND (DTDATA NOT IN (SELECT DTFERICOMP
                               FROM FERICOMP
                              WHERE (CDFILIAL   = P_CDFILIOPELOG)
                                AND (DTFERICOMP < P_DTENTREGA)))))
       ORDER BY DTDATA DESC;
BEGIN
   V_ENTREGA_MENOS_ANO := P_DTENTREGA - 364;
   V_ENTREGA_MENOS_DIA := P_DTENTREGA - 1;
   V_NRLIMISEGU        := 0;
   V_DTENTREGA         := P_DTENTREGA;

   SELECT NVL(MAX(TO_NUMBER(NRDIAEMBARQUE)),0), NVL(MAX(IDSOMENTEUTIL), 'S')
     INTO V_NRLIMISEGU, V_IDDNULIMSEG
     FROM DATAEMBARQUEOLCLIE, PRODUTO
    WHERE DATAEMBARQUEOLCLIE.CDPRODUTO    = PRODUTO.CDPRODUTO
      AND DATAEMBARQUEOLCLIE.CDCLIENTE    = P_CDCLIENTE
      AND DATAEMBARQUEOLCLIE.CDFILIOPELOG = P_CDFILIOPELOG
      AND PRODUTO.CDARVPROD = (SELECT MAX(CDARVPROD)
                                 FROM DATAEMBARQUEOLCLIE A, PRODUTO B
                                WHERE A.CDCLIENTE    = P_CDCLIENTE
                                  AND A.CDFILIOPELOG = P_CDFILIOPELOG
                                  AND A.CDPRODUTO    = B.CDPRODUTO
                                  AND INSTR(P_CDARVPROD, B.CDARVPROD) = 1);
   IF V_NRLIMISEGU > 0 THEN
      OPEN C_MAIORDATA;
      FOR V_NRCONTA IN 1..V_NRLIMISEGU LOOP
         /* Busca a ltima data ate o n de dias para embarque */
         FETCH C_MAIORDATA INTO V_DTENTREGA;
         EXIT WHEN C_MAIORDATA%NOTFOUND;
      END LOOP;
      CLOSE C_MAIORDATA;
   END IF;

   V_CONTAUXI := 1;
   WHILE V_CONTAUXI > 0 LOOP
      SELECT COUNT(*) INTO V_CONTAUXI
        FROM FERICOMP
       WHERE CDFILIAL   = P_CDFILIOPELOG
         AND DTFERICOMP = V_DTENTREGA;

      IF V_CONTAUXI > 0 THEN
         V_DTENTREGA := V_DTENTREGA - 1;
      END IF;
   END LOOP;

   RETURN(V_DTENTREGA);
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('CALC_DTEMBARQUECLI_OL','5.80.XXX'); END;
/

