function sup03500_parametrizacao_de_produtos_para_suprimentosController(General, Utilities, RestEngine, ScreenService, MessageService, templateManager){
    
    this.productRangeValidations = function (field) {
        const widgetRow = field.widget.currentRow;
        
        if (!validaProduto(widgetRow.CDPRODINI, widgetRow.CDPRODFIN)) 
        {
            field.clearValue();
        }
    };
    
    function validaProduto(prodInicial, prodFinal) {
        
        if (prodInicial && prodFinal) {
            if (!General.comparaPratoProduto(prodInicial, prodFinal, getLocalVar('CDPICTPROD'))) {
                MessageService.showMessageByCode("PRODUTO_INICIAL_MENOR_IGUAL_FINAL");
                return false;
            }
        }

        return true;
    }
    
    this.subGrupoFilterReadOnly = function(widget){
        
        if(!Util.isEmptyOrBlank(widget.getField('OL').value())){
            widget.getField('SUBGRUPO').readOnly = false;
            
            widget.getField('SUBGRUPO').dataSourceFilter = [
                {
                    name: 'P_CDFILIOPELOG',
                    operator: '=',
                    value: concatArrayForParams(widget.currentRow.CDFILIAL),
                }
            ];
            
            if(!Util.isEmptyOrBlank(widget.getField('REGIAO').value())){
                this.unidadeFilterReadOnly(widget);
            }
        }else{
            widget.getField('SUBGRUPO').readOnly = true;
            
            widget.getField('UNIDADE').setValue(null);
            widget.getField('UNIDADE').readOnly = true;
        }
        
        widget.getField('SUBGRUPO').setValue(null);
        
    };
    
    this.unidadeFilterReadOnly = function(widget){
        if(!Util.isEmptyOrBlank(widget.getField('OL').value()) && !Util.isEmptyOrBlank(widget.getField('REGIAO').value())){
            const fieldUnidade = widget.getField('UNIDADE');
        
            fieldUnidade.readOnly = false;
            
            fieldUnidade.dataSourceFilter = [
                {
                    name: 'P_CDREGIAO',
                    operator: '=',
                    value: concatArrayForParams(widget.currentRow.CDREGIAO),
                },
                {
                    name: 'P_CDFILIOPELOG',
                    operator: '=',
                    value: concatArrayForParams(widget.currentRow.CDFILIAL),
                }
            ];
        }else{
            widget.getField('UNIDADE').readOnly = true;
            widget.getField('UNIDADE').setValue(null);
            MessageService.showMessageByCode("PREENCHER_CAMPOS_ANTERIORES");
        }
        
    };
    
    this.openExclusaoAutomaticaWidget = function(widget) {
        const exclusao = widget.container.getWidget('exclusaoAutomaticaWidget');
        
        ScreenService.openPopup(exclusao);
    };
    
    this.backPopup = function(widget) {
        widget.getField('UNIDADE').readOnly = true;
        widget.getField('SUBGRUPO').readOnly = true;
        widget.currentRow = {};
        ScreenService.closePopup();
    };
    
    this.openInclusaoAutomaticaWidget = function(widget) {
        const inclusao = widget.container.getWidget('inclusaoAutomaticaWidget');
        
        ScreenService.openPopup(inclusao);
    };
    
    this.subGrupoExcIncAuto = function(widget,action){
        if(widget.getField('OL').value()){
            widget.getField('SUBGRUPO').readOnly = false;
            if(!Util.isEmptyOrBlank(widget.getField('REGIAO').value())){
                this.unidadeExcInc(action);
            }
        }else{
            widget.getField('SUBGRUPO').readOnly = true;
            widget.getField('UNIDADE').readOnly = true;
        }
    };
    
    function procedureExcInc(widget, row){
        General.callRestEngine('opl_parametros#/sup03500ParametrizacaoProdutosSuprimentosController/procedureExcInc','Row', row).then(function(res){
        	MessageService.showMessageByCode("OPERACAO_SUCESSO");
        	ScreenService.closePopup();
            widget.container.getWidget('parametrizacao_de_produtos_para_suprimentos_widget').reload();
        }, function(error) {
            var errorMessage = "Timeout";
            let textContentError = '';
            if (error.data){
                errorMessage = "ERR_GENERICO";
                textContentError = error.data.error;
            }
            MessageService.showMessageByCode(errorMessage, {"PARAM":textContentError});
        });
    }
    
    this.excQuestion = function(widget){
        let row;
        MessageService.confirmMessageByCode("CONFIRMA_EXCLUCAO_ITENS").then(function (success) {
            
            row = {
                CDFILIOPELOG: widget.currentRow.CDFILIAL,
                CDFILIAL: concatArrayForParams(widget.currentRow.CDFILIALUN),
                CDREGIAO: concatArrayForParams(widget.currentRow.CDREGIAO),
                CDSUBGRPROD: concatArrayForParams(widget.currentRow.CDSUBGRPROD),
                CDPRODINI: widget.currentRow.CDPRODINI,
                CDPRODFIN: widget.currentRow.CDPRODFIN ? formataProdFinal(widget.currentRow.CDPRODFIN) : "",
                OPERACAO: '4',
                CDFILISUBGR: 'P',
                IDOPERLOG: 'N'
            };
            
            procedureExcInc(widget,row);
        });
    };
    
    this.incQuestion = function(widget){
        let row;
        MessageService.confirmMessageByCode("CONFIRMA_INCLUSAO_ITENS").then(function (success) {
            
            row = {
                CDFILIOPELOG: widget.currentRow.CDFILIAL,
                CDFILIAL: concatArrayForParams(widget.currentRow.CDFILIALUN),
                CDREGIAO: concatArrayForParams(widget.currentRow.CDREGIAO),
                CDSUBGRPROD: concatArrayForParams(widget.currentRow.CDSUBGRPROD),
                CDPRODINI: widget.currentRow.CDPRODINI,
                CDPRODFIN: widget.currentRow.CDPRODFIN ? formataProdFinal(widget.currentRow.CDPRODFIN) : "",
                OPERACAO: '4',
                CDFILISUBGR: 'P',
                IDOPERLOG: 'S'
            };
            
            procedureExcInc(widget,row);
        });
        
    };
    
    this.checkInc = function(args){
        const widget = args.owner;
        
        if (widget.inEditMode()) {
            return args.e.preventDefault();
        }
        
        const filterRow = widget.appliedFilter.FILTER_ROW;
        const selectedRow = widget.selectedRow;
        let row;
        row = {
                CDFILIOPELOG: filterRow.CDFILIAL,
                CDFILIAL: selectedRow.CDFILIAL,
                CDREGIAO: selectedRow.CDREGIAO,
                CDSUBGRPROD: selectedRow.CDSUBGRPROD,
                CDPRODINI: selectedRow.CDARVPROD,
                CDPRODFIN: selectedRow.CDARVPROD,
                OPERACAO: '4',
                CDFILISUBGR: 'P',
                IDOPERLOG: 'S'
            };
            
        procedureExcInc(widget,row);
    };
    
    this.checkExc = function(args){
        const widget = args.owner;
        
        if (widget.inEditMode()) {
            return args.e.preventDefault();
        }
        
        const filterRow = widget.appliedFilter.FILTER_ROW;
        const selectedRow = widget.selectedRow;
        let row;
        row = {
                CDFILIOPELOG: filterRow.CDFILIAL,
                CDFILIAL: selectedRow.CDFILIAL,
                CDREGIAO: selectedRow.CDREGIAO,
                CDSUBGRPROD: selectedRow.CDSUBGRPROD,
                CDPRODINI: selectedRow.CDARVPROD,
                CDPRODFIN: selectedRow.CDARVPROD,
                OPERACAO: '4',
                CDFILISUBGR: 'P',
                IDOPERLOG: 'N'
            };
            
        procedureExcInc(widget,row);
    };
    
    this.toggleModeInclusionExclusionAll = function(widget) {
        if (!widget.inEditMode()) {
            widget.edit(false);
        }
    };
    
    function concatArrayForParams(value, defaultValue = 'T'){
        if (!Util.isEmptyOrBlank(value)) {
            return Array.isArray(value) ? value.join('_') : value;
        }
    
        return defaultValue;
    }
    
    this.unidadeExcInc = function(action){
        let widget;
        if(action == "E"){
            widget = templateManager.container.getWidget('exclusaoAutomaticaWidget');
        }else{
            widget = templateManager.container.getWidget('inclusaoAutomaticaWidget');
        }
        
        if(widget.getField('OL').value() && !Util.isEmptyOrBlank(widget.getField('REGIAO').value())){
            const fieldUnidade = widget.getField('UNIDADE');
        
            fieldUnidade.readOnly = false;
            
            fieldUnidade.dataSourceFilter = [
                {
                    name: 'P_CDREGIAO',
                    operator: '=',
                    value: concatArrayForParams(widget.currentRow.CDREGIAO),
                },
                {
                    name: 'P_CDFILIOPELOG',
                    operator: '=',
                    value: concatArrayForParams(widget.currentRow.CDFILIAL),
                }
            ];
        }else{
            widget.getField('UNIDADE').readOnly = true;
            widget.getField('UNIDADE').setValue(null);
            MessageService.showMessageByCode("PREENCHER_CAMPOS_ANTERIORES");
        }
        
    };
    
    this.subGrupoExcInc = function(action){
        let widget;
        if(action == "E"){
            widget = templateManager.container.getWidget('exclusaoAutomaticaWidget');
        }else{
            widget = templateManager.container.getWidget('inclusaoAutomaticaWidget');
        }
        
        if(widget.getField('OL').value()){
            const fieldSubGrupo = widget.getField('SUBGRUPO');
        
            fieldSubGrupo.readOnly = false;
            
            fieldSubGrupo.dataSourceFilter = [
                {
                    name: 'P_CDFILIOPELOG',
                    operator: '=',
                    value: concatArrayForParams(widget.currentRow.CDFILIAL),
                }
            ];
        }
        
    };
    
    this.initiateFilter = function (widget) {
    	    
    	Utilities.startFilter(widget);
    };
    
    function formataProdFinal(prodFin){
        var pad = 'ZZZZZZZZZZZZZZZZZZZZ';
        return prodFin + pad.substr(0, pad.length - prodFin.length);
    }
    
    this.beforeApplyFilter = function (args) {
        args.e.preference.CUSTOM_FILTER_ROW = {};
        const widget = templateManager.container.getWidget('parametrizacao_de_produtos_para_suprimentos_widget');
        const filterRow = args.e.preference.FILTER_ROW;
        const parametrizado = filterRow.PARAMETRIZADO;
        let paramOperator;
        let value;
        
        if (parametrizado == "S") {
            paramOperator = ">";
            value = 0;
        } else if(parametrizado == "N"){
            paramOperator = "=";
            value = 0;
        } else {
            paramOperator = "<>";
            value = -1;
        }
        
        widget.dataSourceFilter = [
            {
                name: 'P_CDREGIAO',
                operator: '=',
                value: concatArrayForParams(filterRow.CDREGIAO)
            },
            {
                name: 'P_CDFILIOPELOG',
                operator: '=',
                value: filterRow.CDFILIAL
            },
            {
                name: 'P_CDSUBGRPROD',
                operator: '=',
                value: concatArrayForParams(filterRow.CDSUBGRPROD)
            },
            {
                name: 'P_CDPRODINI',
                operator: '=',
                value: filterRow.CDPRODINI
            },
            {
                name: 'P_CDPRODFIN',
                operator: '=',
                value: filterRow.CDPRODFIN ? formataProdFinal(filterRow.CDPRODFIN) : ""
            },
            {
                name: 'P_CDFILIAL',
                operator: '=',
                value: concatArrayForParams(filterRow.CDFILIALUN)
            },
            {
                name: 'CONTADOR',
                operator: paramOperator,
                value: value
            }
        ];
        
    };
    
    this.cancelGridOperations = function (args) {
        const widget = args.owner.widget;
        
        General.backOrCancel(args);
        widget.list();
        widget.reload();
    };
    
    
    /**
     * TODO:
     * - [] Colocar as funções do CANCELAR em uma única função no controller
     * - [] Verificar se o .list() resolve em vez do backOrCancel
     * - [] Verificar o impacto do reload do floatingControl quando está com o editMode
     */
    this.afterLoadDataSource = function (widget){
        if (widget.inEditMode()) return;
        
        if (widget.dataSource.data.length) {
            widget.dataSource.data.forEach(function(row){
                row.__isSelected = (row.CONTADOR > 0);
            });
        }
        
    };
}

Configuration(function(ContextRegister){
    ContextRegister.register('sup03500_parametrizacao_de_produtos_para_suprimentosController',sup03500_parametrizacao_de_produtos_para_suprimentosController);
});